
Application['devMan'] = (function() {
  var module = {exports: {}};
  var exports = module.exports;
  Application['devMan'] = exports;

  /* router : devMan */
module.name = "devMan";
module.routes = {"deviceManager":"index"};
new (Backbone.Router.extend({
  routes: module.routes
  ,index: function() {
        var vent             = _.extend({}, Backbone.Events); //event aggregator
        var _this            = this;
        Application.sessions = new Thorax.Collections["sessions"]();
        Application.sessions.fetch({
            success:function(){
                var sessions = Application.sessions;
                sessions.initSession();

                var encSessions     = new Thorax.Collections["devMan/encSessions"](null,{sessions:sessions, vent:vent});
                var encSessionsView = new Application.Views["devMan/encSessionsView"]({collection: sessions.byType('encoder'), vent:vent});
                var decSessions     = new Thorax.Collections["devMan/decSessions"](null,{sessions:sessions, vent:vent});
                var decSessionsView = new Application.Views["devMan/decSessionsView"]({collection: sessions.byType('decoder'), vent:vent});
                var indexView       = new Application.Views["devMan/index"]({
                    vent:vent
                    ,encSessionsView:encSessionsView
                    ,decSessionsView:decSessionsView
                });
                Application.setView(indexView);
            },error:function(){ alert('no sputnik sessions available!');}});
   }

}));
;;
Handlebars.templates['devMan/index'] = Handlebars.compile('<div class=\"container\" style=\"margin-top:80px; min-height:100%;\">\n  <div class=\"row\">\n      <div class=\"col-md-12\" style=\" background-color:#000; min-height:900px;\">\n            <section>\n              <div class=\"row\">\n                <div>\n                  <div class=\"col-md-5\">\n                  <div class=\"container-fluid\" style=\"background-color: #053C2D; vertical-align: top; width:100%; color:#fff; border-radius: 5px 5px 0 0;\">\n                      <section>Encoders</section>\n                  </div>                    \n                  <div id=\"encoder-sessions\" class=\"container-fluid\" style=\"background-color: #122020; min-height:555px; box-shadow: 5px 5px 3px #000;\"> \n                    <br>\n                        {{view encSessionsView}}\n                    </div>\n                  </div>\n                  <div class=\"col-md-1\">\n                  <div class=\"row\" style=\"text-align:center;\">\n                  <div class=\"col-xs-6 col-md-8 col-lg-10 vcenter\">\n                    <div class=\"flex-center-vertically\">\n                      <span>Pair</span><span class=\"glyphicon glyphicon-circle-arrow-right\" class=\"devicePair\" id=\"devicePair\" title=\"Pair\" style=\"font-size:3em;\"></span>\n                    </div>\n                  </div>\n                  </div>\n                  </div>\n                  <div class=\"col-md-6\">\n                  <div class=\"container-fluid\" style=\"background-color: #375a7f; vertical-align: top; color:#fff; width:100%; border-radius: 10px 10px 0 0;\">\n                      <section>Decoders</section>\n                    </div>        \n                    <div id=\"decoder-sessions\" class=\"container-fluid\" style=\"background-color: #143b4d; min-height:555px; box-shadow: 5px 5px 3px #000;\">\n                    <br>\n                        {{view decSessionsView}}\n                    </div>\n                  </div>\n                </div>\n              </div>\n            </section>\n  </div>\n  <br><br>\n\n  <br>\n</div>\n');Application.View.extend({
    name: "devMan/index"
    ,initialize:function(){
        //,encSessionsView:encSessionsView
        //,decSessionsView:decSessionsView
        //vent
        var _this = this;
        this.selectedEncoder = null;
        this.selectedDecoder = null;


        this.vent.on('update-snapshots', function(){
            _this.setupSnapshot().done();
        });

        this.vent.on('decoder-selected', function(data){
            _this.decoderArray(data);
            _this.selectedDecoder = data;
           _this.pair();
        });
        this.vent.on('encoder-selected', function(data){
            // var backgroundInterval = setInterval(function(){
            //      $('.decoderRows').toggleClass("selected");
            //  },700);
            // setTimeout(function(){
            //     clearInterval(backgroundInterval);
            //      $('.decoderRows').removeClass("selected");
            // }, 1500);
           _this.selectedEncoder = data;
            var decoderArray = localStorage['decoderArray'] ? JSON.parse(localStorage['decoderArray']) : false; 
            if (decoderArray){
                _.each(decoderArray, function(decoder){
                    $("#"+decoder.id+"-row").removeClass("selected");
                });
                localStorage['decoderArray'] = [];

            }
        });
        
        _this.rtpServerIsRunning().done(function(rtpServerRunning) {
            localStorage.setItem('rtpServerRunning', rtpServerRunning);
        });

        this.vent.on('decoder-unselected', function(data){
            var decoderArrayStorage      = JSON.parse(localStorage['decoderArray']);
            var remove                   = _.findWhere(decoderArrayStorage, {id: data.get("id")});
            var newDecoderArrayStorage   = _.without( decoderArrayStorage, remove);

            localStorage['decoderArray'] = JSON.stringify(newDecoderArrayStorage);
        });

        setTimeout(function(){
            _this.mapRelationships();
            $("#devicePair").css({'cursor':'not-allowed', 'opacity':'.5'}).off();
        }, 3000);

    }
    ,mapRelationships: function(){
        var _this = this;
        var deviceRelationships = localStorage.getItem('deviceRelationships') ? JSON.parse(localStorage.getItem('deviceRelationships')) : false;
        _this.setupSnapshot().done();
        if(deviceRelationships){
            _.each(deviceRelationships, function(decoders, encoder){
                _.each(decoders, function(decoder){
                    $("#"+decoder+"-decoder-img-0").attr("data-device-id", encoder);
                    var friendlyName = $("."+encoder+"-Services_Zeroconf_friendlyname").first().text();
                    $("#"+decoder+"-pair").text(' pairing to '+friendlyName).css({'color':'#CCC', 'font-size':'.75em'});
                    //$("#"+decoder+"-decoder-img-0").addClass("showPreview");
                });
            _this.setupSnapshot().done();
            });
        }
    }
    ,decoderArray: function (data) {
        var decoderArrayStorage = localStorage['decoderArray'] ? JSON.parse(localStorage['decoderArray']) : [];
        if(!(decoderArrayStorage[0])){
            decoderArrayStorage.push(data);
            localStorage['decoderArray'] = JSON.stringify(decoderArrayStorage);
        } else {
            var cloneAndPush = _.map(decoderArrayStorage, _.clone);
            cloneAndPush.push(data);
            localStorage['decoderArray'] = JSON.stringify(cloneAndPush);
        }
    }
    ,pair:function(){
        var _this = this; 
        var decodersSelected = localStorage['decoderArray'] ? localStorage['decoderArray'] : false; 
        if( decodersSelected && this.selectedEncoder ){
            var enc_id = _this.selectedEncoder.get('id');
            $("#devicePair")
                .on()
                .css({'opacity':'1'})
                .hover(function(){
                    $(this).css({'cursor':'pointer', 'color':'#00BC8C'});
                }, function(){
                    $(this).css({'color':'#FFF'});
                })
                .unbind('click')
                .on('click', function(){
                    //_this.rtpServerIsRunning().done(function(rtpServerRunning) {
                        var rtpServerRunning =localStorage.getItem('rtpServerRunning');
                        if(rtpServerRunning == 1){
                            if ($(".not-selected").length) {
                                _this.pleaseWait.show(_this,'You cannot pair this encoder with the decoder(s) due to the present status of the encoder.', false);
                            } else {

                                decodersSelected  = localStorage['decoderArray'] ? localStorage['decoderArray'] : false; 
                                var parseDecoders = JSON.parse(decodersSelected);
                                var parseSize     = _.size(parseDecoders) -1;

                                var deviceArray = [];

                                _.each(parseDecoders, function(selectedDecoder, i){
                                    enc_id = _this.selectedEncoder.get('id');
                                    var dec_id = selectedDecoder.id;
                                    deviceArray.push(dec_id);
                                    // $("#"+selectedDecoder.id+"-decoder-img-0").attr("data-device-id", enc_id);
                                    // $("#"+selectedDecoder.id+"-decoder-img-0").addClass("showPreview");
                                    // $("#"+selectedDecoder.id+"-decoder-img-1").addClass("showPreview");
                                    var backgroundInterval = setInterval(function(){
                                         $("#"+selectedDecoder.id+"-row").toggleClass("selected");
                                     },200);
                                    setTimeout(function(){
                                        clearInterval(backgroundInterval);
                                    }, 2500);
                                    _this.setupSnapshot().done();
                                    _this.pairRequest(enc_id, dec_id, parseSize, i);
                                });

                                var deviceRelationships = localStorage.getItem('deviceRelationships') ? JSON.parse(localStorage.getItem('deviceRelationships')) : {};
                                if(deviceRelationships[enc_id]) delete deviceRelationships[enc_id]; 

                                _.each(deviceRelationships, function(decoderArray, id){
                                    if(id != enc_id){
                                        decoderArray = _.difference(decoderArray, deviceArray);
                                        deviceRelationships[id] = decoderArray;
                                    } 
                                });

                                deviceRelationships[enc_id] = deviceArray;
                                localStorage.setItem('deviceRelationships',JSON.stringify(deviceRelationships));
                                _this.mapRelationships();
                            }
                        } else {
                            _this.pleaseWait.show(_this,'You must enable the RTP/RTSP Server in order to pair an encoder with decoders.', true)
                        }
                   // });
                });
        }
    }
    , pairRequest: function(enc_id, dec_id, parseKeySize, index){

        console.log("Attempting to pair", enc_id, "with", dec_id);
        $.ajax({
            url:'/'+enc_id+'/pair'
            ,data:{'with':dec_id}
        }).done(function(data){
            console.log("Paired", enc_id, "with", dec_id);
            if(parseKeySize == index) {
            }
        }).error(function(data){
        });

    }
    ,setupSnapshot:function(){
        var dfd = $.Deferred(); 
        $('.previewSnapshotTip').filter('.showPreview').each(function(){
             var $snapshot = $(this);
             var nosnap    = '/images/awsnap.png';
             var nosignal  = '/images/no-input-signal.png';
             $(this).attr('src', nosnap);
             $(this).show();

             var updatePreview = function(){
                $snapshot.attr('src', $snapshot.attr('data-device-id')+'/snapshot?height=118&_='+new Date().getTime());
                dfd.resolve();
             };

             $snapshot.load(function(){
                 var imgUrl = $(this).attr('src');
                 if( imgUrl != nosnap && imgUrl != nosignal ){
                     $(this).data('timeout', setTimeout(updatePreview,3000))
                     $('.nosignal,.nosnap').hide();
                 }

             }).error(function(){
                 $(this).attr('src', nosnap);
                 $(this).data('timeout', setTimeout(updatePreview,5000));
             });
            updatePreview();

        });
        return dfd.promise();
    },
    rtpServerIsRunning: function(){
        var _this = this;
        var dfd = $.Deferred(); 

        $.ajax({url:'/sputnik/settings',
            contentType:'application/json',
            type:'GET'
        }).done(function(data){
            if(data.rtp_server ==='no'){
                dfd.resolve(0);
            } else {
                dfd.resolve(1);
            }
        });
        return dfd.promise();

    },
    rtpServerStart: function(){
        var _this = this;
        var rtspConfig = {rtp_server:"yes"};
        $.ajax({url:'/sputnik/settings',
            contentType:'application/json',
            type:'POST', data:JSON.stringify(rtspConfig)
        }).done(function(){
            _this.rtpServerIsRunning();
        });
    },
    pleaseWait: {
        show: function(_this, prompt, special) {
            var btn = '&nbsp;';
            if(special) btn='<button class="btn btn-primary btnRTPEnable">Enable</button>&nbsp;&nbsp;&nbsp;&nbsp';
            pleaseWaitDiv = $('<div class="coderSettings modal fade in" aria-hidden="false" id="pleaseWaitDialog" role="dialog" data-backdrop="static" data-keyboard="false"><div class="modal-dialog"><div class="modal-content"><div class="modal-header"><h4 class="loadingImg" style="display:none;"><img src="/images/ajax-loader.gif"> Loading....</h4><h2 class="modalWarning">Warning</h2>'
                +'</div><div class="modal-body">'+prompt+'<br><br>'+btn+'<button class="btn btn-default btnRTPClose" data-dismiss="modal">Close</button></div></div></div></div>');
            pleaseWaitDiv.modal();
            if(special){ 
                $(pleaseWaitDiv).find(".btnRTPEnable").on('click', function(){
                    $(pleaseWaitDiv).find(".loadingImg").show();
                    $(pleaseWaitDiv).find(".modal-body").hide();
                    $(pleaseWaitDiv).find(".modalWarning").hide();
                    _this.rtpServerStart();
                    $.ajax({'url':'/restart'})
                    .done(function(){
                        setTimeout(function(){
                            window.location.reload();
                        },15000);
                    });
                })
            }
        },
        hide: function () {
            pleaseWaitDiv.modal('hide');
        }
    }
});

// Instances of this view can be created by calling:
// new Application.Views["devMan/index"]()


;;
Application.Collection.extend({
   name: "devMan/encSessions"
  ,initialize:function(){
  }
});

// Instances of this collection can be created by calling:
// new Application.Collections["devMan/encSession"]()
;;
Application.Collection.extend({
  name: "devMan/decSessions"
});

// Instances of this collection can be created by calling:
// new Application.Collections["devMan/decSession"]()
;;
Handlebars.templates['devMan/decSessionsView'] = Handlebars.compile('\n{{#collection tag=\"ul\" class=\"table-striped\"}}\n<li class=\"decoder\">\n<div class=\"content\">\n<div class=\"row decoderRows codeRowSpan\"  style=\"min-height:90px;max-height:155px;-webkit-box-shadow: 1px 2px 1px -1px #232526; -moz-box-shadow: 1px 2px 1px -1px #232526; box-shadow: 1px 2px 1px -1px #232526;\" id=\"{{id}}-row\">\n\n<div class=\"col-md-12\">\n\n  <div class=\"row\">\n    <div class=\"col-md-10\" style=\"vertical-align:middle; margin-top:5px;\">\n    <img class=\"previewSnapshotTip\" style=\"display:none; padding:5px; max-width:100px\" id=\"{{id}}-decoder-img-0\" data-device-id=\"{{id}}\"> <img id=\"{{id}}-decoder-img-1\" class=\"nosnap\" src=\"/images/awsnap.png\" style=\"display:none; padding:5px; max-width:100px\">\n\n    <span style=\"font-size: 1em;\" class=\"{{id}}-Services_Zeroconf_friendlyname\">{{name}} </span> \n    <div class=\"row\">\n      <div class=\"col-md-5\" style=\"color:#DDD;font-size:.75em;\">\n      Status: <span class=\"{{id}}-VideoDecoder_Status_1_status\">Loading</span>\n\n      </div>\n      <div class=\"col-md-3\" style=\"color:#DDD;font-size:.75em;\">\n      Type: <span class=\"{{id}}-VideoPlayer_Settings_1_mode\"></span>\n\n      </div>\n      <div class=\"col-md-4\" style=\"color:#DDD;font-size:.75em;\">\n      Resolution: <span class=\"{{id}}-VideoOutput_Configuration_outputformat\"></span>\n\n      </div>\n    </div>\n    <span id=\"{{id}}-pair\"></span>\n    </div>\n    <div class=\"col-md-2\" style=\"vertical-align:middle; margin-top:5px;\">\n    <span title=\"Settings\" class=\"glyphicon glyphicon-cog gearBtn\" style=\"font-size:1.5em; vertical-align:center; padding:10px; display:none;\" id=\"settings{{id}}\" data-1=\"{{id}}\"  data-toggle=\"modal\" data-target=\"#uiSettings{{id}}\"></span>\n    <img src=\"/images/ajax-loader.gif\" id=\"settingsLoad{{id}}\">\n    </div>\n\n  </div>\n</div>\n\n<div class=\"coderSettings modal fade in\" role=\"dialog\" aria-hidden=\"false\" aria-labelledby=\"myModalLabel\" id=\"uiSettings{{id}}\">\n  <div class=\"modal-dialog\">\n    <div class=\"modal-content\">\n      <div class=\"modal-header\">\n        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-hidden=\"true\">×</button>\n        <h4 class=\"modal-title {{id}}-Services_Zeroconf_friendlyname\" id=\"myModalLabel\">{{name}}</h4>\n      </div>\n      <div class=\"modal-body\">\n\n        <div class=\"form-group\" id=\"dv-{{id}}-errors\" style=\"display:none;\">\n          <label for=\"{{id}}-errors\" class=\"col-sm-2 control-label\">Errors</label>\n          <div class=\"col-sm-10\">\n            <span id=\"{{id}}-errors\" style=\"background-color:#ff0000\"></span>\n          </div>\n        <br><br>\n        </div>\n\n        <div class=\"form-group\">\n          <label for=\"{{id}}-VideoPlayer_Settings_1_mode\" class=\"col-sm-2 control-label\">Decoder Mode</label>\n          <div class=\"col-sm-10\">\n            <select id=\"{{id}}-VideoPlayer_Settings_1_mode\" style=\"width:100%\" class=\"form-control VideoPlayer_Settings_1_mode\" data-device-id=\"{{id}}\">\n              <!--<option value=\"TDS\">Teradek Stream</option>-->\n              <option value=\"RTSP\" selected=\"true\">RTP/RTSP</option>\n              <!--<option value=\"RTPPush\">RTP Push</option>-->\n              <option value=\"TS\">MPEG Transport Stream</option>\n            </select>\n          </div>\n                  <br><br>\n        </div>\n\n\n        <div class=\"form-group\" id=\"dv-{{id}}-VideoPlayer_Settings_1_TS_protocol\">\n          <label for=\"{{id}}-VideoPlayer_Settings_1_TS_protocol\" class=\"col-sm-2 control-label\">Protocol</label>\n          <div class=\"col-sm-10\">\n            <select id=\"{{id}}-VideoPlayer_Settings_1_TS_protocol\" style=\"width:100%\" class=\"form-control VideoPlayer_Settings_1_TS_Protocol\" data-device-id=\"{{id}}\">\n              <option role=\"presentation\" value=\"tcp\" name=\"tcp\">TCP</option>\n              <option role=\"presentation\" value=\"udp\" name=\"udp\">UDP</option>\n              <option role=\"presentation\" value=\"multicast\" name=\"multicast\">Multicast</option>\n              <option role=\"presentation\" value=\"tcp_pull\" name=\"tcp_pull\">TCP Pull</option>\n            </select>\n          </div>\n        <br><br>\n        </div>\n        <div class=\"form-group\" id=\"dv-{{id}}-VideoPlayer_Settings_1_RTSP_proto\">\n          <label for=\"{{id}}-VideoPlayer_Settings_1_RTSP_proto\" class=\"col-sm-2 control-label\">Protocol</label>\n          <div class=\"col-sm-10\">\n            <select id=\"{{id}}-VideoPlayer_Settings_1_RTSP_proto\" style=\"width:100%\" class=\"form-control\">\n              <option role=\"presentation\" value=\"tcp\" name=\"tcp\">TCP</option>\n              <option role=\"presentation\" value=\"udp\" name=\"udp\">UDP</option>\n            </select>\n          </div>\n        <br><br>\n        </div>\n        <div class=\"form-group\" id=\"dv-{{id}}-VideoPlayer_Settings_1_RTSP_name\">\n          <label for=\"{{id}}-VideoPlayer_Settings_1_RTSP_name\" class=\"col-sm-2 control-label\">Name</label>\n          <div class=\"col-sm-10\">\n            <input id=\"{{id}}-VideoPlayer_Settings_1_RTSP_name\" type=\"text\" class=\"form-control\">\n          </div>\n        <br><br>\n        </div>\n        <div class=\"form-group\" id=\"dv-{{id}}-VideoPlayer_Settings_1_RTSP_host\">\n          <label for=\"{{id}}-VideoPlayer_Settings_1_RTSP_host\" class=\"col-sm-2 control-label\">Host</label>\n          <div class=\"col-sm-10\">\n            <input id=\"{{id}}-VideoPlayer_Settings_1_RTSP_host\" type=\"text\" class=\"form-control\">\n          </div>\n        <br><br>\n        </div>\n        <div class=\"form-group\" id=\"dv-{{id}}-VideoPlayer_Settings_1_TS_host\">\n          <label for=\"{{id}}-VideoPlayer_Settings_1_TS_host\" class=\"col-sm-2 control-label\">Host</label>\n          <div class=\"col-sm-10\">\n            <input id=\"{{id}}-VideoPlayer_Settings_1_TS_host\" type=\"text\" class=\"form-control\">\n          </div>\n        <br><br>\n        </div>\n        <div class=\"form-group\" id=\"dv-{{id}}-VideoPlayer_Settings_1_TS_port\">\n          <label for=\"{{id}}-VideoPlayer_Settings_1_TS_port\" class=\"col-sm-2 control-label\">Port</label>\n          <div class=\"col-sm-10\">\n            <input id=\"{{id}}-VideoPlayer_Settings_1_TS_port\" type=\"text\" class=\"form-control\">\n          </div>\n        <br><br>\n        </div>\n        <div class=\"form-group\" id=\"dv-{{id}}-VideoPlayer_Settings_1_TS_Server_host\">\n          <label for=\"{{id}}-VideoPlayer_Settings_1_TS_Server_host\" class=\"col-sm-2 control-label\">Host</label>\n          <div class=\"col-sm-10\">\n            <input id=\"{{id}}-VideoPlayer_Settings_1_TS_Server_host\" type=\"text\" class=\"form-control\">\n          </div>\n        <br><br>\n        </div>\n        <div class=\"form-group\" id=\"dv-{{id}}-VideoPlayer_Settings_1_TS_Server_port\">\n          <label for=\"{{id}}-VideoPlayer_Settings_1_TS_Server_port\" class=\"col-sm-2 control-label\">Port</label>\n          <div class=\"col-sm-10\">\n            <input id=\"{{id}}-VideoPlayer_Settings_1_TS_Server_port\" type=\"text\" class=\"form-control\">\n          </div>\n        <br><br>\n        </div>\n        <div class=\"form-group\" id=\"dv-{{id}}-VideoPlayer_Settings_1_TDS_port\">\n          <label for=\"{{id}}-VideoPlayer_Settings_1_TDS_port\" class=\"col-sm-2 control-label\">Port</label>\n          <div class=\"col-sm-10\">\n            <input id=\"{{id}}-VideoPlayer_Settings_1_TDS_port\" type=\"text\" class=\"form-control\">\n          </div>\n        <br><br>\n        </div>\n\n        <div class=\"form-group\" id=\"dv-{{id}}-VideoPlayer_Settings_1_TDS_host\">\n          <label for=\"{{id}}-VideoPlayer_Settings_1_TDS_host\" class=\"col-sm-2 control-label\">Host</label>\n          <div class=\"col-sm-10\">\n            <input id=\"{{id}}-VideoPlayer_Settings_1_TDS_host\" type=\"text\" class=\"form-control\">\n          </div>\n        <br><br>\n        </div>\n        \n        <div class=\"form-group\" id=\"dv-{{id}}-VideoPlayer_Settings_1_RTPPush_videoport\">\n          <label for=\"{{id}}-VideoPlayer_Settings_1_RTPPush_videoport\" class=\"col-sm-2 control-label\">Video Port</label>\n          <div class=\"col-sm-10\">\n            <input id=\"{{id}}-VideoPlayer_Settings_1_RTPPush_videoport\" type=\"text\" class=\"form-control\">\n          </div>\n        <br><br>\n        </div>\n\n        <div class=\"form-group\" id=\"dv-{{id}}-VideoPlayer_Settings_1_RTPPush_audioport\">\n          <label for=\"{{id}}-VideoPlayer_Settings_1_RTPPush_audioport\" class=\"col-sm-2 control-label\">Audio Port</label>\n          <div class=\"col-sm-10\">\n            <input id=\"{{id}}-VideoPlayer_Settings_1_RTPPush_audioport\" type=\"text\" class=\"form-control\">\n          </div>\n        <br><br>\n        </div>\n\n        <div class=\"form-group\" id=\"dv-{{id}}-VideoPlayer_Settings_1_RTSP_port\">\n          <label for=\"{{id}}-VideoPlayer_Settings_1_RTSP_port\" class=\"col-sm-2 control-label\">Port</label>\n          <div class=\"col-sm-10\">\n            <input id=\"{{id}}-VideoPlayer_Settings_1_RTSP_port\" type=\"text\" class=\"form-control\">\n          </div>\n        <br><br>\n        </div>\n\n        <div class=\"form-group\" id=\"dv-{{id}}-VideoOutput_Configuration_outputformat\">\n          <label for=\"{{id}}-VideoOutput_Configuration_outputformat\" class=\"col-sm-2 control-label\">Output Resolution</label>\n          <div class=\"col-sm-10\">\n            <select style=\"width: 100%;\"class=\"form-control\" id=\"{{id}}-VideoOutput_Configuration_outputformat\">\n              <option value=\"480p\" name=\"hdmi\">480p60</option>\n              <option value=\"576p\" name=\"hdmi\">576p50</option>\n              <option value=\"720p50\" name=\"hdmi\">720p50</option>\n              <option value=\"720p59\" name=\"hdmi\">720p59</option>\n              <option value=\"720p\" name=\"hdmi\" >720p60</option>\n              <option value=\"1080i50\" name=\"hdmi\">1080i50</option>\n              <option value=\"1080i59\" name=\"hdmi\">1080i59</option>\n              <option value=\"1080i\" name=\"hdmi\">1080i60</option>\n              <option value=\"1080p23\" name=\"hdmi\">1080p23</option>\n              <option value=\"1080p24\" name=\"hdmi\">1080p24</option>\n              <option value=\"1080p25\" name=\"hdmi\">1080p25</option>\n              <option value=\"1080p29\" name=\"hdmi\">1080p29</option>\n              <option value=\"1080p30\" name=\"hdmi\">1080p30</option>\n              <option value=\"auto\" name=\"hdmi\">Auto</option>\n\n              <option value=\"480i\" name=\"sdi\">480i60</option>\n              <option value=\"480iH\" name=\"sdi\">480i60 Widescreen</option>\n              <option value=\"576i\" name=\"sdi\">576i50</option>\n              <option value=\"576iH\" name=\"sdi\">576i50 Widescreen</option>\n              <option value=\"720p50\" name=\"sdi\">720p50</option>\n              <option value=\"720p59\" name=\"sdi\">720p59</option>\n              <option value=\"720p\" name=\"sdi\">720p60</option>\n              <option value=\"1080i50\" name=\"sdi\">1080i50</option>\n              <option value=\"1080i59\" name=\"sdi\">1080i59</option>\n              <option value=\"1080i\" name=\"sdi\">1080i60</option>\n              <option value=\"1080p23\" name=\"sdi\">1080p23</option>\n              <option value=\"1080p24\" name=\"sdi\">1080p24</option>\n              <option value=\"1080p25\" name=\"sdi\">1080p25</option>\n              <option value=\"1080p29\" name=\"sdi\">1080p29</option>\n              <option value=\"1080p30\" name=\"sdi\">1080p30</option>\n            </select>\n\n          <br><br>\n          </div>\n        </div>\n        <br><br>\n        <div class=\"form-group\">\n          <label for=\"{{id}}-VideoDecoder_Configuration_latency_target\" class=\"col-sm-2 control-label\">Caching</label>\n          <div class=\"col-sm-10\">\n              <input id=\"{{id}}-VideoDecoder_Configuration_latency_target\" type=\"number\" min=\"70\" max=\"1000\" class=\"form-control\"> (Valid Range: 70-1000)\n          </div>\n        </div>\n        <br><br>\n        <div class=\"form-group\">\n          <label for=\"{{id}}-AudioDecoder_Configuration_mode\" class=\"col-sm-2 control-label\">Audio</label>\n          <div class=\"col-sm-10\">\n            <span class=\"glyphicon\" data-decoderId=\"{{id}}\" id=\"{{id}}-AudioDecoder_Configuration_mode\" style=\"font-size:4em;\"></span>\n          </div>\n          <br><br>\n        </div>    <br><br>\n        <div class=\"form-group\">\n          <label for=\"{{id}}-AudioDecoder_Configuration_samplerate\" class=\"col-sm-2 control-label\">Audio Sample Rate</label>\n          <div class=\"col-sm-10\">\n            <select style=\"width: 100%;\"class=\"form-control\" id=\"{{id}}-AudioDecoder_Configuration_samplerate\">\n              <option value=\"16000\">16000 Hz</option>\n              <option value=\"32000\">32000 Hz</option>\n              <option value=\"44100\">44100 Hz</option>\n              <option value=\"48000\">48000 Hz</option>\n            </select>\n          </div>\n        <br><br>\n        </div>\n\n\n      </div>\n      <div class=\"modal-footer\">\n        <button type=\"button\" class=\"btn btn-default\" data-dismiss=\"modal\">Close</button>\n        <button type=\"submit\" class=\"decoderSave btn btn-primary\" data-decoderId=\"{{id}}\"  >Save changes</button>\n      </div>\n    </div>\n  </div>\n</div>\n\n</div>\n</div>\n</div>\n</li>\n{{/collection}}');Application.View.extend({
    name: "devMan/decSessionsView"
    ,events:{
         'click .decoder .col-md-12':function(event){
             var model = $(event.target).model();
             if ( $(event.currentTarget.parentNode).hasClass('selected') ) {
               $(event.currentTarget.parentNode).removeClass('selected');
               this.vent.trigger('decoder-unselected', model);
             } else { 
               $(event.currentTarget.parentNode).addClass('selected');
               this.vent.trigger('decoder-selected', model);
             }
         }
         ,'click .glyphicon': function(event){
            var model = $(event.target);
            if ( $(event.currentTarget).hasClass('glyphicon-volume-up') ) {
              model.removeClass('glyphicon-volume-up');
              model.addClass('glyphicon-volume-off');
              model.attr("data-value", "disabled");
            } else if ( $(event.currentTarget).hasClass('glyphicon-volume-off') ){
              model.addClass('glyphicon-volume-up');
              model.removeClass('glyphicon-volume-off');
              model.attr("data-value", "enabled");
            }
         }
         ,"click .decoderSave": function(event){
          var _this = this; 
            var decoderId = $(event.target).attr("data-decoderId");
            this.saveModels(decoderId).done(function(modelSaved){
              if(modelSaved){
                var enableElement = '#settings'+decoderId;
                $("#settingsLoad"+decoderId).hide();
                $(enableElement).css('color', "#ffffff").prop('disabled', false).show();
                _this.render();
                _this.vent.trigger('update-snapshots');
              } else {
                $("#settingsLoad"+decoderId).hide();
              }
            });
         }
         ,"change .VideoPlayer_Settings_1_mode": function(event){
            var model = $(event.target);
            var deviceId = model.attr('data-device-id');
            this.showHideModels(deviceId, model.val(), 1, true);
            if (model.val() == 'TS') {
              $("#"+deviceId+"-"+"VideoPlayer_Settings_1_TS_protocol").val("tcp");
            }
         }
         ,"change .VideoPlayer_Settings_1_TS_Protocol": function(event){
            var model = $(event.target);
            var deviceId = model.attr('data-device-id');
            this.showHideModels(deviceId, model.val(), 2, true);
         }
     }
     ,models : function(){
        return ['VideoOutput.Configuration.outputformat','VideoOutput.Configuration.outputmode','VideoPlayer.Settings.1.TS.Server.host','VideoPlayer.Settings.1.TS.Server.port','VideoPlayer.Settings.1.TS.host','VideoPlayer.Settings.1.RTSP.name','Services.Zeroconf.friendlyname','VideoDecoder.Status.1.status','VideoPlayer.Settings.1.TDS.port','VideoPlayer.Settings.1.TDS.host','VideoPlayer.Settings.1.TS.port','VideoPlayer.Settings.1.TS.protocol','VideoPlayer.Settings.1.RTPPush.audioport','VideoPlayer.Settings.1.RTPPush.videoport','VideoDecoder.Configuration.latency_target','AudioDecoder.Configuration.samplerate', 'VideoPlayer.Settings.1.mode', 'VideoDecoder.Status.1.status', 'VideoPlayer.Settings.1.RTSP.proto','VideoPlayer.Settings.1.RTSP.host', 'VideoPlayer.Settings.1.RTSP.port', 'AudioDecoder.Configuration.mode'];
     }
     ,ping: function(device){
        var _this = this;
        var statusTypes = ['Not Decoding', 'No Frames Decoded Yet', 'Decoding', 'Starting', 'Error'];
        setInterval(function(){
          _this.getDevice(device, false, 'VideoDecoder.Status.1.status,VideoPlayer.Settings.1.RTSP.name', true).done(function(data){
            console.log("Decoder Status Check", device.id, data);
            var VideoDecoderStatus = _this.extractChildofObject(data, 'VideoDecoder.Status.1.status');
            var targetModel        = _this.extractChildofObject(data, 'VideoPlayer.Settings.1.RTSP.name.value');
            $("."+device.id+"-VideoDecoder_Status_1_status").text(statusTypes[VideoDecoderStatus]);
            var friendlyName       = $("."+targetModel+"-Services_Zeroconf_friendlyname").first().text();
            var streamType         = $("."+device.id+"-VideoPlayer_Settings_1_mode").first().text();
            if (streamType === 'TS') $("."+device.id+"-pair").text(" ");
            if ( !(!friendlyName || friendlyName ==="" || friendlyName == undefined || friendlyName == null) && (streamType != 'TS')) $("#"+device.id+"-pair").text(' paired to '+friendlyName).css({'color':'#CCC', 'font-size':'.75em'});
          });

        }, 5000);
     }
     ,associateErrorHandler: function(deviceId, model, type){

        if(type == undefined) type="";
        var parseType = type.split(" ");

        var inputType = parseType[0];
        var message   = Application.helper.typeHandler[inputType] ? Application.helper.typeHandler[inputType].message : '';
        var regex     = Application.helper.typeHandler[inputType] ? Application.helper.typeHandler[inputType].regex   : '';
        var type      = Application.helper.typeHandler[inputType] ? Application.helper.typeHandler[inputType].type    : false;
        parseType     = _.without( parseType, _.findWhere(parseType, inputType) );
        
        _.each(parseType, function(item){
          if(type === 'integer') item = parseInt(item);
          if(typeof item == 'number') message += " " +item + " -";
          if(typeof item == 'string') message += " " +item + ",";
        });
        message = message.substring(0, message.length - 1);

        if (regex) $('#'+deviceId+'-'+model).attr('pattern', regex)

        if (type)  {
          $('#'+deviceId+'-'+model).attr('data-type', type);
        } else {
          $('#'+deviceId+'-'+model).attr('data-type', "_");
        }

        $('#'+deviceId+'-'+model).attr('data-error-message', message);

     }
     ,showHideModels: function(deviceId, modeSetting, type, setting){
        var rtspModels        = ['VideoPlayer.Settings.1.RTSP.proto','VideoPlayer.Settings.1.RTSP.host', 'VideoPlayer.Settings.1.RTSP.port', 'VideoPlayer.Settings.1.RTSP.name'];
        var tsModelsProt      = ['VideoPlayer.Settings.1.TS.protocol'];
        var tsPort            = ['VideoPlayer.Settings.1.TS.port'];
        var tdsModels         = ['VideoPlayer.Settings.1.TDS.port','VideoPlayer.Settings.1.TDS.host'];
        var RTPPushModel      = ['VideoPlayer.Settings.1.RTPPush.audioport','VideoPlayer.Settings.1.RTPPush.videoport'];
        var multicProtocol    = ['VideoPlayer.Settings.1.TS.host','VideoPlayer.Settings.1.TS.port'];
        var tsTcpPullProtocol = ['VideoPlayer.Settings.1.TS.Server.host','VideoPlayer.Settings.1.TS.Server.port']
        var tsModelsChildren  = [tsPort, multicProtocol, tsTcpPullProtocol];
        var tsModels          = [tsModelsProt, tsPort];

        function hideModels(){
          var modModel;
          var targetElement;

          _.each(arguments, function(argument){
            _.each(argument, function(subargument){
              if (typeof subargument == 'string'){
                modModel = subargument.replace(/\./g, "_");
                targetElement = '#dv-'+deviceId+"-"+modModel;
                $(targetElement).hide();
              } else {
                _.each(subargument, function(model){
                  modModel = model.replace(/\./g, "_");
                  targetElement = '#dv-'+deviceId+"-"+modModel;
                  $(targetElement).hide();
                });
              }
            });
          });
        }

        function showModelType(modelType){
            _.each(modelType, function(model){
              var modModel = model.replace(/\./g, "_");
              var targetElement = '#dv-'+deviceId+"-"+modModel;
              $(targetElement).show();
            });
        }

        if (type == 1) {
            switch(modeSetting) {
              case 'RTSP':
                  hideModels(tsModels, tdsModels, RTPPushModel, tsModelsChildren);
                  showModelType(rtspModels);

                  break;
              case 'TS':
                  hideModels(rtspModels, tdsModels, RTPPushModel);
                  showModelType(tsModelsProt);
                  if(setting) showModelType(tsPort);
                  break;
              case 'TDS':
                  hideModels(rtspModels, tsModels, RTPPushModel, tsModelsChildren);
                  showModelType(tdsModels);

                  break;
              case 'RTPPush':
                  hideModels(rtspModels, tdsModels, tsModels, tsModelsChildren);
                  showModelType(RTPPushModel);

                  break;
              default:
                  hideModels(tsModels, tdsModels, RTPPushModel, tsModelsChildren);
                  showModelType(rtspModels);

                  break;
            }
        } else if (type == 2) {
            switch(modeSetting) {
              case 'multicast':
                  hideModels(tsPort, tsTcpPullProtocol);
                  showModelType(multicProtocol);
                  break;
              case 'tcp_pull':
                  hideModels(tsPort, multicProtocol);
                  showModelType(tsTcpPullProtocol);
                  break;
              case 'udp':
                  hideModels(multicProtocol, tsTcpPullProtocol);
                  showModelType(tsPort);
                  break;
              case 'tcp':
                  hideModels(multicProtocol, tsTcpPullProtocol);
                  showModelType(tsPort);
                  break;
              default:
                  hideModels(multicProtocol, tsTcpPullProtocol);
                  showModelType(tsPort);
                  break;
            }
        }
     }
     ,initialize: function(){
        var _this = this;
        _.each(_this.collection.models, function(model, i){
          var last = false;
          // if(i == 0){
          //   _this.pleaseWait.show("Please wait...");
          // }
          var count = _this.collection.models.length -1;
          if (i == count){
            last = true;
          }
          _this.ping(model);
          _this.getDevice(model, last).done(function(data){
            _this.setModels(data, model.id);
          });
        });
     }
     ,getDevice: function(model, last, prop, type){
        var _this = this;
        var jsonCmd;
        var apiEndPoint;
        if(!prop) {
          jsonCmd = _this.models().toString();
        } else {
          jsonCmd = prop;
        }
        if(!type){
          apiEndPoint = '/settings';
        } else {
          apiEndPoint = '/setting';
        }
          var dfd = $.Deferred();
          $.ajax({
            type: "GET",
            url: '/json/'+model.id+apiEndPoint,
            data: {q:jsonCmd},
            dataType: 'json',
            success:function(data){
                  // console.log('data', data);
                  dfd.resolve(data);
                }
          });
          return dfd.promise();
     },setDevice: function(device, settings){
        var _this = this;
        var dfd   = $.Deferred();
        $.ajax({
          type: "POST",
          url: '/json/'+device+'/settings',
          data: settings,
          dataType: 'json',
          success:function(data){
            _this.checkResponse(device, data);
            dfd.resolve(true);
          }
        });
        return dfd.promise();
     }
     ,checkResponse: function(device, data){

      var _this            = this;
      var responseArray    = [];
      var hasError         = false; 
      var extract          = '';
      String.prototype.has = function(it) { return this.indexOf(it) != -1; };

      _.each(_this.models(), function(model){
        try {
          extract = _this.extractChildofObject(data, model);
          if (extract && extract != undefined && extract != null){

            if ( extract.has("##Invalid") ) {
              var pair = {};
              extract = extract.replace(/\#/g, "");
              pair[model] = extract
              hasError = true
              responseArray.push(pair);
            }
          } 
        }
        catch(e){
          //console.log(e);
        }
        var modModel = model.replace(/\./g, "_");
        var targetElement = '#'+device+"-"+modModel;
        $(targetElement).css('color','#000000');
      })

      if(hasError){
        setTimeout(function(){
          var errorMessage ='';
          _.each(responseArray, function(response){
            var model    = _.keys(response);
            var message  = _.values(response);
            var modModel = model[0].toString().replace(/\./g, "_");
            var targetElement = '#'+device+"-"+modModel;
            $(targetElement).css('color','#ff0000');
            errorMessage += message[0] + '<br>';
          });

          $("#"+device+"-errors").html(errorMessage);
          $("#dv-"+device+"-errors").show();
          $("#uiSettings"+device).modal('show');

          return false;
        },1000);
      } else {
          $("#dv-"+device+"-errors").hide();
        return true;
      }

     }
     ,extractChildofObject: function(obj, path){
        path = path.split('.');
        for (i = 0; i < path.length - 1; i++)
            obj = obj[path[i]];
        return obj[path[i]];
     }
     ,setModels: function(data, deviceId){
        var _this = this;
        _.each(_this.models(), function(model){
          var targetModel    = _this.extractChildofObject(data, model);
          var modModel       = model.replace(/\./g, "_");
          var targetElement  = '#'+deviceId+"-"+modModel;
          var cTargetElement = '.'+deviceId+"-"+modModel;
          var enableElement  = '#settings'+deviceId;
          $("#settingsLoad"+deviceId).hide();
          $(enableElement).css('color', "#ffffff").prop('disabled', false).show();

          if(model == 'VideoDecoder.Status.1.state' || model == 'VideoDecoder.Status.1.status') {
            $(targetElement).val(targetModel);
            $(targetElement).attr("data-original-value", targetModel);
            $(targetElement).attr("data-value", targetModel);
          } else {
            $(targetElement).val(targetModel.value);
            $(targetElement).attr("data-original-value", targetModel.value);
            $(targetElement).attr("data-value", targetModel.value);
            $(targetElement).attr("data-save", 1);
          }

          _this.associateErrorHandler(deviceId, modModel, targetModel.type);

          if(model == 'VideoPlayer.Settings.1.mode'){
            _this.showHideModels(deviceId, targetModel.value, 1, false);
          }
          if (model == 'VideoPlayer.Settings.1.TS.protocol'){
            _this.showHideModels(deviceId, targetModel.value, 2, false);
          }
          if(model == 'VideoOutput.Configuration.outputmode'){
            if (targetModel.value == 'hdmi') $('#'+ deviceId +'-VideoOutput_Configuration_outputformat option[name="sdi"]').hide();
            if (targetModel.value == 'sdi')  $('#'+ deviceId +'-VideoOutput_Configuration_outputformat option[name="hdmi"]').hide();
          }

          if(model == 'AudioDecoder.Configuration.mode'){
              if (targetModel.value == 'enabled') $(targetElement).addClass('glyphicon-volume-up');
              if (targetModel.value == 'disabled') $(targetElement).addClass('glyphicon-volume-off');
          }
          try {
            var selectTargetElement;
            if(model == 'VideoDecoder.Status.1.state' || model == 'VideoDecoder.Status.1.status') {
              var statusTypes = ['Not Ready', 'Not Ready', 'Decoding', 'Starting', 'Error'];
              var stateTypes = ['Not Ready', 'Started'];
              if (model == 'VideoDecoder.Status.1.status'){
                $(cTargetElement).text(statusTypes[targetModel]);
              } else {
                $(cTargetElement).text(stateTypes[targetModel]);
              }
              selectTargetElement = targetElement+" option:[value="+targetModel+"]";

            } else {
              $(cTargetElement).text(targetModel.value);
              selectTargetElement = targetElement+" option:[value="+targetModel.value+"]";
            }

            $(selectTargetElement).attr('selected', true);

          } 
          catch(e){
            //console.log(e);
          }
        });
     }
     ,saveModels: function(deviceId){
        var _this          = this;
        var dfd            = $.Deferred();
        var models         = _this.models();
        var settings       = {};
        var disableElement ='#settings'+deviceId;
        var hasError       = false;
        var errors         = [];

        $(disableElement).css('color', "#ff0000").prop('disabled', true).hide();

        _.each(models, function(model, i){

          var modModel          = model.replace(/\./g, "_");
          var targetElement     = '#'+deviceId+"-"+modModel;
          var modelValue        = $(targetElement).val();
          var modelType         = $(targetElement).attr('data-type');
          var modelOriginalValue= $(targetElement).attr("data-original-value");
          var saveData          = $(targetElement).attr("data-save");
          var modelDataValue    = $(targetElement).attr("data-value");
          var modelRegEx        = $(targetElement).attr("pattern");
          var modelError        = $(targetElement).attr("data-error-message");
          var regex             = false;

          if(modelRegEx && modelRegEx != undefined){
            regex  = new RegExp(modelRegEx);
          } 

          var tester;
         if (modelRegEx != undefined ) {
            if(regex) tester = regex.test(modelValue);
          }


          var cTargetElement = '.'+deviceId+"-"+modModel;
          $("#settingsLoad"+deviceId).show();

          if (modelOriginalValue != modelValue && saveData == 1){
            settings[model] = modelValue;
            $(targetElement).attr("data-original-value", modelValue);
            $(targetElement).attr("data-value", modelValue);
            try {
              $(cTargetElement).text(modelValue);
              if (tester === false) {
                $(targetElement).css("color", "#FF0000");
                hasError = true;
                console.log(modelError);
                if (modelError != undefined || modelError != 'undefined') errors.push(modelError); 
              } else {
                $(targetElement).css("color", "#000");
              }
            } catch(e){
              console.log(e);
            }
          } else if(modelDataValue != modelOriginalValue  && saveData == 1) {
            settings[model] = modelDataValue;
            $(targetElement).attr("data-original-value", modelDataValue);
            $(targetElement).attr("data-value", modelDataValue);
            try {
              $(cTargetElement).text(modelDataValue);
            } catch(e){
              console.log(e);
            }
          }
        });
  

        if (hasError){

          var errorMessage ="";
          errors.forEach(function(error){
            if (error != "undefined") errorMessage += error + '<br>';
          });
          
          $("#"+deviceId+"-errors").html(errorMessage);
          $("#dv-"+deviceId+"-errors").show();

          return dfd.resolve(false);
        } else {
           $("#dv-"+deviceId+"-errors").hide();
           $("#uiSettings"+deviceId).modal('hide');
          _this.setDevice(deviceId, settings).done(function(devicesSet){
            if (devicesSet){
              return dfd.resolve(true);
            }
          });
        }

        return dfd.promise();
     }
});

// Instances of this view can be created by calling:
// new Application.Views["devMan/decSessionsView"]()
;;
Handlebars.templates['devMan/encSessionsView'] = Handlebars.compile('{{#collection tag=\"ul\" class=\"table-striped\"}}\n<li class=\"encoder\">\n<div class=\"content\">\n\n\n\n<div class=\"row codeRowSpan\"  style=\"min-height:90px;max-height:155px;-webkit-box-shadow: 1px 2px 1px -1px #232526; -moz-box-shadow: 1px 2px 1px -1px #232526; box-shadow: 1px 2px 1px -1px #232526;\">\n\n<div class=\"col-md-12\">\n  <div class=\"row\" style=\"background-color:#191919;\">\n  <div class=\"col-md-12\" style=\"color:#DDD; font-size:.75em;\">\n  </div>\n  </div>\n</div>\n<div class=\"col-md-10\">\n<span style=\"font-size: 1em;\" class=\"{{id}}-Services_Zeroconf_friendlyname\">{{name}}</span><br>\n<img class=\"previewSnapshotTip showPreview\" id=\"encoder{{id}}\" data-device-id=\"{{id}}\" style=\"padding:5px; max-width:100px\"><img class=\"nosnap showPreview\" src=\"/images/awsnap.png\" style=\"display:none; padding:5px; max-width:100px\">&nbsp;&nbsp;<span style=\"font-size:.75em;\"> Status: <span class=\"{{id}}-VideoEncoder_Status_1_status\"> Loading</span><br> </span>\n  </div>\n<div class=\"col-md-2\">\n  <span class=\"glyphicon glyphicon-cog gearBtn\" title=\"Settings\" style=\"font-size:1.5em; vertical-align:center; padding:10px; display:none;\" id=\"settings{{id}}\" data-1=\"{{id}}\"  data-toggle=\"modal\" data-target=\"#uiSettings{{id}}\"></span>\n<img src=\"/images/ajax-loader.gif\" id=\"settingsLoad{{id}}\">\n\n<div class=\"coderSettings modal fade in\" role=\"dialog\" aria-hidden=\"false\" aria-labelledby=\"myModalLabel\" id=\"uiSettings{{id}}\">\n  <div class=\"modal-dialog\">\n    <div class=\"modal-content\">\n      <div class=\"modal-header\">\n        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-hidden=\"true\">×</button>\n        <h4 class=\"modal-title {{id}}-Services_Zeroconf_friendlyname\" id=\"myModalLabel\">{{name}}</h4>\n      </div>\n      <div class=\"modal-body\">\n        <div class=\"form-group\">\n              <ul>\n                  <li>\n                  <label>Audio Input:</label>\n                  <select id=\"{{id}}-AudioEncoder_Configuration_mode\" style=\"width: 100%;\"class=\"form-control\">\n                      <option value=\"hdmi\">HDMI</option>\n                      <option value=\"sdi\">SDI</option>\n                      <option value=\"analog\">Analog</option>\n                      <option value=\"disabled\">Disabled</option>\n                  </select>\n                  </li>\n                  <li>\n                   <label>Encoder Resolution:</label>\n                   <select id=\"{{id}}-VideoEncoder_Settings_1_resolution\" style=\"width: 100%;\"class=\"form-control\">\n                        <option value=\"native\">native</option>\n                        <option value=\"1080\">1080</option>\n                        <option value=\"720\">720</option>\n                        <option value=\"576W\">576W</option>\n                        <option value=\"576\">576</option>\n                        <option value=\"480W\">480W</option>\n                        <option value=\"480\">480</option>\n                        <option value=\"360\">360</option>\n                        <option value=\"270\">270</option>\n                        <option value=\"240\">240</option>\n                    </select>\n                   </li>\n               <li>\n                   <label>Max Bitrate:</label>\n                      <select id=\"{{id}}-Bond_Configuration_max_bitrate\" style=\"width: 100%;\"class=\"form-control\">\n                          <option value=\"128000\">128 kbps</option>\n                          <option value=\"192000\">192 kbps</option>\n                          <option value=\"256000\">256 kbps</option>\n                          <option value=\"400000\">400 kbps</option>\n                          <option value=\"500000\">500 kbps</option>\n                          <option value=\"768000\">768 kbps</option>\n                          <option value=\"1000000\">1.0 Mbps</option>\n                          <option value=\"1500000\">1.5 Mbps</option>\n                          <option value=\"2000000\">2.0 Mbps</option>\n                          <option value=\"2500000\">2.5 Mbps</option>\n                          <option value=\"3000000\">3.0 Mbps</option>\n                          <option value=\"3500000\">3.5 Mbps</option>\n                          <option value=\"4000000\">4.0 Mbps</option>\n                          <option value=\"4500000\">4.5 Mbps</option>\n                          <option value=\"5000000\">5.0 Mbps</option>\n                          <option value=\"6000000\">6.0 Mbps</option>\n                          <option value=\"7000000\">7.0 Mbps</option>\n                          <option value=\"8000000\">8.0 Mbps</option>\n                          <option value=\"9000000\">9.0 Mbps</option>\n                          <option value=\"10000000\">10.0 Mbps</option>\n                     </select>\n                </li>\n                   <li>\n                   <label>Audio Bitrate:</label>\n                    <select id=\"{{id}}-AudioEncoder_Settings_1_audio_bitrate\" style=\"width: 100%;\"class=\"form-control\">\n                          <option value=\"16000\">16 kbps</option>\n                          <option value=\"32000\">32 kbps</option>\n                          <option value=\"44100\">44.1 kbps</option>\n                          <option value=\"48000\">48 kbps</option>\n                          <option value=\"96000\">96 kbps</option>\n                          <option value=\"128000\">128 kbps</option>\n                          <option value=\"192000\">192 kbps</option>\n                          <option value=\"256000\">256 kbps</option>\n                      </select>\n                  </li>\n              </ul>\n            </div>\n      </div>\n      <div class=\"modal-footer\">\n        <button type=\"button\" class=\"btn btn-default\" data-dismiss=\"modal\">Close</button>\n        <button type=\"submit\" class=\"encoderSave btn btn-primary\" data-encoderId=\"{{id}}\"  data-dismiss=\"modal\">Save changes</button>\n      </div>\n    </div>\n  </div>\n</div>\n</div>\n</div>\n</div>\n</li>\n{{/collection}}');Application.View.extend({
    name: "devMan/encSessionsView"
    ,events:{
        'click .encoder .col-md-10': 'setPair'
       ,'click .encoderSave': function(event){
        var _this = this; 
          var encoderId = $(event.target).attr("data-encoderId");
          this.saveModels(encoderId).done(function(modelSaved){
            if(modelSaved){
              var enableElement = '#settings'+encoderId;
              $("#settingsLoad"+encoderId).hide();
              $(enableElement).css('color', "#ffffff").prop('disabled', false).show();
              _this.render();
              _this.vent.trigger('update-snapshots');
            }
          });
        }
     }
     ,setPair: function(event){
       var model = $(event.target).model();
       var targetModel = $("."+model.id+"-VideoEncoder_Status_1_status").attr('data-status-id');
       var _this = this;
        try {
          if(targetModel == 0 || targetModel == 1 || targetModel == 2 || targetModel == 7){
            // $("#devicePair")
            //   .hover(function(){
            //         $(this).css('cursor','not-allowed');
            //   })
            //   .unbind('click');
            console.log('Cannot pair with status present on ' + model.id);
            $('.not-selected', _this.el.parentNode).removeClass('not-selected');
            $('.selected', _this.el.parentNode).removeClass('selected');
            $(event.currentTarget.parentNode).addClass('selected');
            $(event.currentTarget.parentNode).addClass('not-selected');
            // _this.events["click .encoder .col-md-10"] = undefined;
            // _this.delegateEvents(_this.events);
          } else {
            $('.not-selected', _this.el.parentNode).removeClass('not-selected');
            $('.selected', _this.el.parentNode).removeClass('selected');
            $(event.currentTarget.parentNode).addClass('selected');
            //$('.glyphicon-circle-arrow-right').prop('disabled', true).removeClass('pairDevice').off().hide();
            //$("#"+model.id+"-devicePair").prop('disabled', false).addClass('pairDevice').on().show();
          }
          _this.vent.trigger('encoder-selected', model);
        }
        catch(e){
          console.log(e);
        }

     }
     ,models: function(){
      return ['Services.Zeroconf.friendlyname','AudioEncoder.Settings.1.audio_bitrate', 'Bond.Configuration.max_bitrate', 'VideoEncoder.Settings.1.resolution',
              'AudioEncoder.Configuration.mode',
              'AudioEncoder.Settings.1','VideoInput.Info.1','VideoEncoder.Settings.1','VideoStreamer.Settings.Quickview.enable',
              'VideoStreamer.Settings.1.mode','VideoStreamer.Settings.1.SputnikDirect','VideoStreamer.Settings.1.TS'];
     }
     ,ping: function(device){
        var _this = this;
        var statusTypes = ['Timer expired. Restarting', 'Starting', 'No Video Sync', 'Video Syncing', 'Sync Alert', 'Encoding','Not Encoding','Encoder Not Started', 'Monitor Timer Expired'];
        setInterval(function(){
          _this.getDevice(device, false, 'VideoEncoder.Status.1.status', true).done(function(data){
            console.log("Encoder Status Check", device.id, data);
            var targetModel = _this.extractChildofObject(data, 'VideoEncoder.Status.1.status');
            $("."+device.id+"-VideoEncoder_Status_1_status").text(statusTypes[targetModel]).attr('data-status-id', targetModel);
          });
        }, 5000);
     }
     ,initialize: function(){
        var _this = this;
        $(this).hover(function(){
          $(this).css('background-color','#00BC8C');
        });

        _.each(_this.collection.models, function(model, i){
          var last  = false;
          var count = _this.collection.models.length -1;
          if (i == count){
            last = true;
          }
          _this.ping(model);
          _this.getDevice(model, last).done(function(data){
            _this.setModels(data, model.id);
          });
          //$('.glyphicon-circle-arrow-right').prop('disabled', true).removeClass('pairDevice').off();
          // console.log(model.id);
          // console.log('running');
          // _this.getDevicePlugins(model, last).done(function(data){
          //   console.log('Device Plugin Data:');
          //   console.log(data);
          // });
        });
     }
     ,getDevice: function(model, last, prop, type){
        var _this = this;
        var jsonCmd;
        var apiEndPoint;
        if(!type){
          apiEndPoint = '/settings';
        } else {
          apiEndPoint = '/setting';
        }
        if(!prop) {
          jsonCmd = _this.models().toString();
        } else {
          jsonCmd = prop;
        }
          var dfd = $.Deferred();
          $.ajax({
            type: "GET",
            url: '/json/'+model.id+apiEndPoint,
            data: {q:jsonCmd},
            dataType: 'json',
            success:function(data){
                  dfd.resolve(data);
                }
          });
          return dfd.promise();
     },setDevice: function(device, settings){
        var _this = this;
        var dfd = $.Deferred();
        $.ajax({
          type: "POST",
          url: '/json/'+device+'/settings',
          data: settings,
          dataType: 'json',
          success:function(data){
            dfd.resolve(true);
          }
        });
        return dfd.promise();
     }
     // ,getDevicePlugins: function(model, last){
     //    var _this = this;
     //    var jsonCmd = _this.models().toString();
     //    var dfd = $.Deferred();
     //      $.ajax({
     //        type: "GET",
     //        url: '/'+model.id+'/pluginParams',
     //        dataType: 'json',
     //        success:function(data){
     //              console.log(data);
     //              //if(last) _this.pleaseWait.hide();
     //              dfd.resolve(data);
     //            },
     //        error: function(data){
     //          console.log(data);
     //        }
     //      });
     //      return dfd.promise();
     //  }
     ,extractChildofObject: function(obj, path){
        path = path.split('.');
        for (i = 0; i < path.length - 1; i++)
            obj = obj[path[i]];
        return obj[path[i]];
     }
     ,setModels: function(data, deviceId){
        var _this = this;
        _.each(_this.models(), function(model){
          var targetModel     = _this.extractChildofObject(data, model);
          var modModel        = model.replace(/\./g, "_");
          var targetElement   = '#'+deviceId+"-"+modModel;
          var cTargetElement  = '.'+deviceId+"-"+modModel;
          var enableElement   = '#settings'+deviceId;
          $("#settingsLoad"+deviceId).hide();
          $(enableElement).css('color', "#ffffff").prop('disabled', false).show();
          $(targetElement).val(targetModel.value);
          $(targetElement).attr("data-original-value", targetModel.value);
          $(targetElement).attr("data-value", targetModel.value);
          try {
            $(cTargetElement).text(targetModel.value);
            var selectTargetElement = targetElement+" option:[value="+targetModel.value+"]";
            $(selectTargetElement).attr('selected', true);
          } 
          catch(e){
            //console.log(e);
          }
        });
     }
     ,saveModels: function(deviceId){
        var _this          = this;
        var dfd            = $.Deferred();
        var models         = _this.models();
        var settings       = {};
        var disableElement ='#settings'+deviceId;
        $(disableElement).css('color', "#ff0000").prop('disabled', true).hide();

        _.each(models, function(model, i){
          var modModel           = model.replace(/\./g, "_");
          var targetElement      = '#'+deviceId+"-"+modModel;
          var modelValue         = $(targetElement).val();
          var modelOriginalValue = $(targetElement).attr("data-original-value");
          var modelDataValue     = $(targetElement).attr("data-value");
          var cTargetElement     = '.'+deviceId+"-"+modModel;
          $("#settingsLoad"+deviceId).show();

          if (modelOriginalValue != modelValue){
            settings[model] = modelValue;
            $(targetElement).attr("data-original-value", modelValue);
            $(targetElement).attr("data-value", modelValue);
            try {
              if (typeof modelValue == boolean){
                if(modelValue){
                  modelValue == "Ready";
                } else {
                  modelValue == "Not Ready";
                }
              }
              $(cTargetElement).text(modelValue);
            } catch(e){

            }
          } else if(modelDataValue != modelOriginalValue) {
            settings[model] = modelDataValue;
            $(targetElement).attr("data-original-value", modelDataValue);
            $(targetElement).attr("data-value", modelDataValue);
            try {
              $(cTargetElement).text(modelValue)
            } catch(e){

            }
          }
        });

        _this.setDevice(deviceId, settings).done(function(devicesSet){
          if (devicesSet){
            return dfd.resolve(true);
          }
        });
        return dfd.promise();
     }
});

// Instances of this view can be created by calling:
// new Application.Views["devMan/encSessionsView"]()
;;


  if (Application['devMan'] !== module.exports) {
    console.warn("Application['devMan'] internally differs from global");
  }
  return module.exports;
}).call(this);
