var _ = require('underscore'),
    config = require(__ROOT__ + '/config/record'),
    Deferred = require('deferred'),
    loaded = {},
    waitForReadyPrm = {
        enable: 0,
        max_length_mb: parseInt(Math.random() * 100),
        max_time_s: parseInt(Math.random() * 100),
        multiple_files: +(Math.random() > 0.5),
        filename: (Math.random() + '').replace('.', '') + '.ts'
    }
    ;


function loadPlugin(app, sid) {
    if (loaded[sid]) return;
    loaded[sid] = 1;
    app.sess(sid).iface('E').enqueue('sputnik:record.load', function (session) {
        var params = [
            'rec_start_enabled=0',
            'rec_max_length_mb=0',
            'rec_max_time_s=0',
            'rec_multiple_files_enabled=0',
            'rec_filename=tmp.ts'
        ];

        session.addPluginParams('udpts', params)(function (pluginId) {
            session.loadPlugin(pluginId)(function () {
                console.log('Record plugin loaded: ' + sid, 'Wait for ready accept commands...');

                function check() {

                    session.getRecordParams({param: "settings"})(
                        function (prm) {

                            if (_.some(waitForReadyPrm, function (val, key) {
                                return prm[key == 'enable' ? 'enabled' : key] != val;
                            })) {
                                session.setRecordParams(waitForReadyPrm);
                                setTimeout(check, 1100);
                            }
                            else {
                                loaded[sid] = true;
                                console.log('Record on ' + sid + ' ready to accept commands');
                            }

                        }, function (err) {
                            console.log('<record:error> Wait...');
                            setTimeout(check, 1100);
                        });
                }

                check();


            }, function (err) {
                throw err;
            });


        }, function (err) {
            console.error(err)
        });
    });
}

module.exports = function (app, sid) {

    loadPlugin(app, sid);

    return {
        start: function start(options) {
            var def = Deferred();

            options.enable = 1;
            app.sess(sid).iface('E').enqueue('sputnik:record.start', function (session) {

                function setParam() {
                    if (loaded[sid] !== true) return setTimeout(setParam, 500);
                    session.setRecordParams(options)(function () {
                        def.resolve(1)
                    }, function () {
                        def.resolve(1)
                    });
                }

                setParam();

            });

            return def.promise;
        },

        stop: function stop() {
            var def = Deferred();
            app.sess(sid).iface('E').enqueue('sputnik:record.stop', function (session) {
                session.setRecordParams({enable: 0})
                def.resolve(1)(
                    function () {
                        def.resolve(1)
                    },
                    function (err) {
                        def.resolve(1);
                    }
                );
            });
            return def.promise;
        }
    };

}
