/*
 * Copyright, 2012, Teradek
 * 
 * All rights reserved.
 * Contact Teradek for licensing.
 */

var redis = require('redis'),
	cli = require('Node-CLI/node-cli.js'),
	colors = require('colors.js'),
	stat = require('./stats');

var curSession = {}, numSessions = 0;

function update_sessions(dbconfig, server, pos) {
	var row = 5 + (pos * 14), col = 4
	var db = redis.createClient(dbconfig.port, dbconfig.host)

	db.smembers("server:" + server + ":sessions", function(err, sessions) {
		sessions.forEach(function(session, sess) {
			stat.display(dbconfig, server, session, row+(sess*12), col);
		});
	});
}

function check_new_sessions(dbconfig, server, pos) {
	var db = redis.createClient(dbconfig.port, dbconfig.host)
	
	db.subscribe("server:" + server + ":sessions");
	
	db.on("message", function(channel, message) {
		if (message == "add") {
			update_sessions(dbconfig, server, pos)
			numSessions++;
		}
		else if (message == "rem") {
			update_sessions(dbconfig, server, pos)
			numSessions--;
		}
	})
	
}

module.exports = {
	"check" : check_new_sessions
}
